/* ==========================================================================*/
/* - - - - - - - - - -  H e a d e r C t r l . c   - - - - - - - - - - - - - -*/
/* ==========================================================================*/
/*	Created   2007-05-07   M. Wheatley                                       */
/*	Modified  2007-05-07   MW                                                */
/*.........................................................................  */
/* VHF Digital Voice Xceiver DSTAR Header Management routines                */

/*---------------------------------------------------------------------------*/
/*------------------------> I N C L U D E S <--------------------------------*/
/*---------------------------------------------------------------------------*/
#include "Board.h"
#include "HeaderCtrl.h"
 
/*---------------------------------------------------------------------------*/
/*--------------------> L O C A L   D E F I N E S <--------------------------*/
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*-------------------> M E M O R Y  A L L O C A T I O N <--------------------*/
/*---------------------------------------------------------------------------*/
U8BIT HeaderBuffer[28*24];	//rcv data entered in array order
							//rcv data removed in interleave order
U32BIT HeaderSymbols[21];	//2 bit symbols packed into this array

tHeaderType DStarHeader;	//formatted D-Star header data structure

/*---------------------------------------------------------------------------*/
/*--------------------------> P R O T O T Y P E S <--------------------------*/
/*---------------------------------------------------------------------------*/

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*                  -------------------------                                */
/*                 | D e I n t e r l e a v e |                               */
/*                  -------------------------                                */
/*    Called to get de-interleaved rcv data from the HeaderBuffer and place  */
/* into the HeaderSymbols Buffer for deconvolution decoding.                 */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
void DeInterleave()
{
}


/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*                  ----------------------                                   */
/*                 |  I n t e r l e a v e |                                  */
/*                  ----------------------                                   */
/*    Called to create interleaved xmit data from the DStarHeader data       */
/* and place into the HeaderBufferinto the HeaderSymbols Buffer for          */
/* deconvolution decoding.                                                   */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
void DeInterleave()
{
}

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*                  ----------------------                                   */
/*                 |  D e S c r a m b l e |                                  */
/*                  ----------------------                                   */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
char DeScramble(char inputbit)
{
static unsigned char sr = 0x7F;
unsigned char xbit;
	xbit = ( (sr&0x40) != 0) ^ ((sr&0x08) != 0);
	sr = sr<<1;
	if(xbit)
	{
		sr |= 1;
		if(inputbit)
			return 0;
		else
			return 1;
	}
	else
	{
		if(inputbit)
			return 1;
		else
			return 0;
	}
}
