/* ==========================================================================*/
/* - - - - - - - - - - -  A m b e 2 0 2 0 . H   - - - - - - - - - - - - - -  */
/* ==========================================================================*/
/*    Definition File for the Ambe2020.c module                              */
/*  Created   2007-03-10	msw                                              */
/*  Modified  2007-03-16    msw                                              */
/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
#ifndef AMBE2020_H_
#define AMBE2020_H_
#include "Common.h"

/* Scheduler includes. */
#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"

/*---------------------------------------------------------------------------*/
/*------------------> G L O B A L   D E F I N E S <--------------------------*/
/*---------------------------------------------------------------------------*/
#define XFERSTATE_FINISHED	0
#define XFERSTATE_LOOKING_FOR_SYNC	1
#define XFERSTATE_RECEIVING	2

#define AMBE2020_FRAME_SYNC	0x13EC
#define AMBE2020_IDLE_WORD	0x0000

#define TIMER2_DATARDY 1	//~41uS
#define TIMER2_DELAY_TO_SYNC_SEARCH 816	//17mSec


#define ECHO_BUF_LENGTH 4096	//~27Seconds


/*---------------------------------------------------------------------------*/
/*-------------------------> T y p e d e f s <-------------------------------*/
/*---------------------------------------------------------------------------*/

typedef union
{
	struct
	{
		U16BIT Hdr;
		U16BIT CW1;
		U16BIT Rate0;
		U16BIT Rate1;
		U16BIT Rate2;
		U16BIT Rate3;
		U16BIT Rate4;
		U16BIT Unused1;
		U16BIT Unused2;
		U16BIT Unused3;
		U16BIT DTMFCtrl;
		U8BIT CW2;
		U8BIT Volume;
		U16BIT ChData[12];
		
	}fld;
	U16BIT All[24];
}tInFrame;

typedef union
{
	struct
	{
		U16BIT Hdr;
		U16BIT CW1;
		U16BIT Rate0;
		U16BIT Rate1;
		U16BIT Rate2;
		U16BIT Rate3;
		U16BIT Rate4;
		U16BIT Unused1;
		U16BIT Unused2;
		U16BIT BitErrors;
		U16BIT DTMFCtrl;
		U16BIT CW2;
		U16BIT ChData[12];
		
	}fld;
	U16BIT All[24];
}tOutFrame;


/*---------------------------------------------------------------------------*/
/*------------------> E x p o s e d    F u n c t i o n s <-------------------*/
/*---------------------------------------------------------------------------*/
void Ambe2020Init( );

/*---------------------------------------------------------------------------*/
/*------------------> E x p o s e d    V a r i a b l e s <-------------------*/
/*---------------------------------------------------------------------------*/
extern tInFrame InFrame;
extern tOutFrame OutFrame;
extern volatile U32BIT SSCTransferIndex;
extern U32BIT SSCTransferSize;
extern volatile U32BIT XferState;
extern xSemaphoreHandle xAmbeBlockRdySemaphore;
extern S32BIT CurrentVolume;
extern U32BIT EchoBuffer[ECHO_BUF_LENGTH+3];
extern S32BIT EchoPointer;
extern S32BIT EchoLength;


#endif /*AMBE2020_H_*/
