/* ==========================================================================*/
/* - - - - - - - - - - - - - -  F P C o m . h   - - - - - - - - - - - - - -  */
/* ==========================================================================*/
/*	Created   2007-03-10   M. Wheatley                                       */
/*	Modified  2007-03-10   MW                                                */
/*.........................................................................  */
/* AT91SAM7  Digital Voice Xceiver Front panel interface                     */
#ifndef FPCOM_H_
#define FPCOM_H_

#include "ascpdefs.h"
/* Scheduler includes. */
#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"

#define MAX_VOICE_BUF 5000

#define EEADR_RXFREQ 0
#define EEADR_TXFREQ 256
#define EEADR_RXVOL 512

#define NORMAL_DISPLAY 0
#define ECHO_DISPLAY 1
#define TUNE_DISPLAY 2


/*---------------------------------------------------------------------------*/
/*------------------> E x p o s e d    F u n c t i o n s <-------------------*/
/*---------------------------------------------------------------------------*/
void FPComInit( void );
void LCDDebug32Bit(unsigned int val);

/*---------------------------------------------------------------------------*/
/*------------------> E x p o s e d    V a r i a b l e s <-------------------*/
/*---------------------------------------------------------------------------*/
extern U16BIT VoiceBuf[MAX_VOICE_BUF];
extern U32BIT VoiceBufStoredSize;
extern U32BIT VoiceBufPtr;
extern volatile S32BIT RotaryChange;
extern U32BIT DisplayMode;

#endif /*FPCOM_H_*/
