/* ==========================================================================*/
/* - - - - - - - - -   T L V 3 2 0 A I C 2 3 B . H   - - - - - - - - - - - - */
/* ==========================================================================*/
/*    Definition File for the TI TLV320AIC3B Codec                           */
/*  Created   2006-10-01                                                     */
/*  Modified  2006-10-01                                                     */
/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
#ifndef TLV320AIC23B_H_
#define TLV320AIC23B_H_

/*---------------------------------------------------------------------------*/
/*-------------------------> D E F I N E S <---------------------------------*/
/*---------------------------------------------------------------------------*/
#define CODEC_SLAVE_ADR (0x1A)	//7 bit I2C address

#define TLV_REG_L_LINEIN_VC (0x00<<9)
#define TLV_REG_R_LINEIN_VC (0x01<<9)
 #define TLV_LINEIN_SIMULT_UPDATE (1<<8)
 #define TLV_LINEIN_MUTE (1<<7)
 #define TLV_LINEIN_VOL_MASK (0x1F<<0)

#define TLV_REG_L_HEADPHONE_VC (0x02<<9)
#define TLV_REG_R_HEADPHONE_VC (0x03<<9)
 #define TLV_HEAD_SIMULT_UPDATE (1<<8)
 #define TLV_HEAD_ZCROSS (1<<7)
 #define TLV_HEAD_VOL_MASK (0x7F<<0)

#define TLV_REG_ANALOG_PATH (0x04<<9)
 #define TLV_SIDETONE_OFF (0<<5)
 #define TLV_SIDETONE_0_DB (0x9<<5)
 #define TLV_SIDETONE_M6_DB (0x1<<5)
 #define TLV_SIDETONE_M9_DB (0x3<<5)
 #define TLV_SIDETONE_M12_DB (0x5<<5)
 #define TLV_SIDETONE_M18_DB (0x7<<5)
 #define TLV_DAC_SELECTED (1<<4)
 #define TLV_BYP_ENABLED (1<<3)
 #define TLV_INPUTSEL_LINE (0<<2)
 #define TLV_INPUTSEL_MIC (1<<2)
 #define TLV_MIC_MUTE (1<<1)
 #define TLV_MIC_BOOST (1<<0)

#define TLV_REG_DIGITAL_PATH (0x05<<9)
 #define TLV_DAC_MUTE (1<<3)
 #define TLV_DEEMP_NONE (0<<1)
 #define TLV_DEEMP_32KHZ (1<<1)
 #define TLV_DEEMP_44HZ (2<<1)
 #define TLV_DEEMP_48HZ (3<<1)
 #define TLV_ADC_HIPASS (1<<0)

#define TLV_REG_POWERDOWN (0x06<<9)
 #define TLV_PWR_ALLOFF (1<<7)
 #define TLV_PWR_CLK (1<<6)
 #define TLV_PWR_OSC (1<<5)
 #define TLV_PWR_OUTPUTS (1<<4)
 #define TLV_PWR_DAC (1<<3)
 #define TLV_PWR_ADC (1<<2)
 #define TLV_PWR_MIC (1<<1)
 #define TLV_PWR_LINE (1<<0)

#define TLV_REG_DIGITAL_FORMAT (0x07<<9)
 #define TLV_MASTERMODE (1<<6)
 #define TLV_DACLRSWAP (1<<5)
 #define TLV_DACLRPHZ (1<<4)
 #define TLV_INPUT_BITS_16 (0<<2)
 #define TLV_INPUT_BITS_20 (1<<2)
 #define TLV_INPUT_BITS_24 (2<<2)
 #define TLV_INPUT_BITS_32 (3<<2)
 #define TLV_DATA_FORMAT_LEFTJUST (0<<0)
 #define TLV_DATA_FORMAT_RIGHTJUST (1<<0)
 #define TLV_DATA_FORMAT_I2S (2<<0)
 #define TLV_DATA_FORMAT_DSP (3<<0)

#define TLV_REG_SAMPLE_RATE (0x08<<9)
 #define TLV_CLKOUT_MCLK (0<<7)
 #define TLV_CLKOUT_MCLK_2 (1<<7)
 #define TLV_CLKIN_MCLK (0<<6)
 #define TLV_CLKIN_MCLK_2 (1<<6)
 #define TLV_OVERSAMPRATE_250_256 (0<<1)
 #define TLV_OVERSAMPRATE_272_384 (1<<1)
 #define TLV_NORMALRATE (0<<0)
 #define TLV_USBRATE (1<<0)
 #define TLV_RATECTRL_MASK (0x0F<<2)	//see TLV320AIC23B data sheet for modes
 #define TLV_RATE_0	(0<<2)
 #define TLV_RATE_1	(1<<2)
 #define TLV_RATE_2	(2<<2)
 #define TLV_RATE_3	(3<<2)
 #define TLV_RATE_4	(4<<2)
 #define TLV_RATE_5	(5<<2)
 #define TLV_RATE_6	(6<<2)
 #define TLV_RATE_7	(7<<2)
 #define TLV_RATE_8	(8<<2)
 #define TLV_RATE_9	(9<<2)
 #define TLV_RATE_10 (10<<2)
 #define TLV_RATE_11 (11<<2)
 #define TLV_RATE_12 (12<<2)
 #define TLV_RATE_13 (13<<2)
 #define TLV_RATE_14 (14<<2)
 #define TLV_RATE_15 (15<<2)


#define TLV_REG_DIGITAL_INTERFACE (0x09<<9)
 #define TLV_INTERFACE_ACTIVE (1<<0)

#define TLV_REG_RESET (0x0F<<9)
 #define TLV_RESETCMD (0)

#endif /*TLV320AIC23B_H_*/
