/* ==========================================================================*/
/* - - - - - - - - - - - - -   U s a r t . h   - - - - - - - - - - - - - - - */
/* ==========================================================================*/
/*    Definition File for the Usartq.c module                                */
/*  Created   2007-03-10	msw                                              */
/*  Modified  2007-03-10    msw                                              */
/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
#ifndef USART_H_
#define USART_H_
#include "Common.h"

/* Scheduler includes. */
#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"

/*---------------------------------------------------------------------------*/
/*------------------> G L O B A L   D E F I N E S <--------------------------*/
/*---------------------------------------------------------------------------*/
#define RXQ_SIZE 32
#define TXQ_SIZE 512

/*---------------------------------------------------------------------------*/
/*------------------> E x p o s e d    F u n c t i o n s <-------------------*/
/*---------------------------------------------------------------------------*/
void UsartInit( U32BIT Rate, U32BIT Parity );
void SendUsart(U8BIT Ch);
void SendUsartStr(U8BIT* buf);
void SendUsartStrWait(U8BIT* buf);
void PrintUsartDebug( char* str, int val, int HexMode);

/*---------------------------------------------------------------------------*/
/*------------------> E x p o s e d    V a r i a b l e s <-------------------*/
/*---------------------------------------------------------------------------*/
extern U8BIT UsartRxQue[RXQ_SIZE];
extern U8BIT UsartTxQue[TXQ_SIZE];
extern volatile U32BIT RxHead;
extern U32BIT RxTail;
extern U32BIT TxHead;
extern volatile U32BIT TxTail;
extern xSemaphoreHandle xUartSemaphore;
extern S32BIT DebugValue1;
extern S32BIT DebugValue2;
extern char ChBuf[80];

#endif /*USART_H_*/
